/*
 * GPIO.h
 *
 *  Created on: Oct 8, 2011
 *      Author: Alexander Vovk
 */

#ifndef GPIO_H_
#define GPIO_H_

#define GPACON		((volatile unsigned *)0x56000000)	//Configures the pins of port A
#define GPADAT		((volatile unsigned *)0x56000004)	//The data register for port A

#define GPBCON		((volatile unsigned *)0x56000010)	//Configures the pins of port B
#define GPBDAT		((volatile unsigned *)0x56000014)	//The data register for port B
#define GPBUP 		((volatile unsigned *)0x56000018)	//Pull-up disable register for port B

#define GPCCON		((volatile unsigned *)0x56000020)	//Configures the pins of port C
#define GPCDAT		((volatile unsigned *)0x56000024)	//The data register for port C
#define GPCUP 		((volatile unsigned *)0x56000028)	//Pull-up disable register for port C

#define GPDCON		((volatile unsigned *)0x56000030)	//Configures the pins of port D
#define GPDDAT		((volatile unsigned *)0x56000034)	//The data register for port D
#define GPDUP 		((volatile unsigned *)0x56000038)	//Pull-up disable register for port D

#define GPECON		((volatile unsigned *)0x56000040)	//Configures the pins of port E
#define GPEDAT		((volatile unsigned *)0x56000044)	//The data register for port E
#define GPEUP 		((volatile unsigned *)0x56000048)	//Pull-up disable register for port E

#define GPFCON		((volatile unsigned *)0x56000050)	//Configures the pins of port F
#define GPFDAT		((volatile unsigned *)0x56000054)	//The data register for port F
#define GPFUP 		((volatile unsigned *)0x56000058)	//Pull-up disable register for port F

#define GPGCON		((volatile unsigned *)0x56000060)	//Configures the pins of port G
#define GPGDAT		((volatile unsigned *)0x56000064)	//The data register for port G
#define GPGUP 		((volatile unsigned *)0x56000068)	//Pull-up disable register for port G

#define GPHCON		((volatile unsigned *)0x56000070)	//Configures the pins of port H
#define GPHDAT		((volatile unsigned *)0x56000074)	//The data register for port H
#define GPHUP 		((volatile unsigned *)0x56000078)	//Pull-up disable register for port H

#define GPJCON		((volatile unsigned *)0x560000d0)	//Configures the pins of port J
#define GPJDAT		((volatile unsigned *)0x560000d4)	//The data register for port J
#define GPJUP 		((volatile unsigned *)0x560000d8)	//Pull-up disable register for port J

/*
 * GPIO configuration
 */

// (R/W)	PORT H CONTROL REGISTERS
// GPHCON, GPHDAT

#define GPACON_RESET				(0xffffff)			//	Reset Value 0xffffff
#define GPBCON_RESET				(0x0)				//	Reset Value 0x0
#define GPCCON_RESET				(0x0)				//	Reset Value 0x0
#define GPDCON_RESET				(0x0)				//	Reset Value 0x0
#define GPECON_RESET				(0x0)				//	Reset Value 0x0
#define GPFCON_RESET				(0x0)				//	Reset Value 0x0
#define GPGCON_RESET				(0x0)				//	Reset Value 0x0

#define GPHCON_RESET				(0x0)				//	Reset Value 0x0

#define GPHCON_10					(0x300000)			// [21:20]		GPH10
#define GPHCON_10_IN				(0x0)				//*00 = Input
#define GPHCON_10_OUT				(0x100000)			// 01 = Output
#define GPHCON_10_CLKOUT1			(0x200000)			// 10 = CLKOUT1

#define GPHCON_9					(0xC0000)			// [19:18]		GPH9
#define GPHCON_9_IN					(0x0)				//*00 = Input
#define GPHCON_9_OUT				(0x40000)			// 01 = Output
#define GPHCON_9_CLKOUT0			(0x80000)			// 10 = CLKOUT0

#define GPHCON_8					(0x30000)			// [17:16]		GPH8
#define GPHCON_8_IN					(0x0)				//*00 = Input
#define GPHCON_8_OUT				(0x10000)			// 01 = Output
#define GPHCON_8_UEXTCLK			(0x20000)			// 10 = UEXTCLK

#define GPHCON_7					(0xC000)			// [15:14]		GPH7
#define GPHCON_7_IN					(0x0)				//*00 = Input
#define GPHCON_7_OUT				(0x4000)			// 01 = Output
#define GPHCON_7_RXD2				(0x8000)			// 10 = RXD[2]
#define GPHCON_7_CTS1				(0xC000)			// 11 = nCTS1

#define GPHCON_6					(0x3000)			// [13:12]		GPH6
#define GPHCON_6_IN					(0x0)				//*00 = Input
#define GPHCON_6_OUT				(0x1000)			// 01 = Output
#define GPHCON_6_TXD2				(0x2000)			// 10 = TXD[2]
#define GPHCON_6_RTS1				(0x3000)			// 11 = nRTS1

#define GPHCON_5					(0xC00)				// [11:10]		GPH5
#define GPHCON_5_IN					(0x0)				//*00 = Input
#define GPHCON_5_OUT				(0x400)				// 01 = Output
#define GPHCON_5_RXD1				(0x800)				// 10 = RXD[1]

#define GPHCON_4					(0x300)				// [9:8]		GPH4
#define GPHCON_4_IN					(0x0)				//*00 = Input
#define GPHCON_4_OUT				(0x100)				// 01 = Output
#define GPHCON_4_TXD1				(0x200)				// 10 = TXD[1]

#define GPHCON_3					(0xC0)				// [7:6]		GPH3
#define GPHCON_3_IN					(0x0)				//*00 = Input
#define GPHCON_3_OUT				(0x40)				// 01 = Output
#define GPHCON_3_RXD0				(0x80)				// 10 = RXD[0]

#define GPHCON_2					(0x30)				// [5:4]		GPH2
#define GPHCON_2_IN					(0x0)				//*00 = Input
#define GPHCON_2_OUT				(0x10)				// 01 = Output
#define GPHCON_2_TXD0				(0x20)				// 10 = TXD[0]

#define GPHCON_1					(0xC)				// [3:2]		GPH1
#define GPHCON_1_IN					(0x0)				//*00 = Input
#define GPHCON_1_OUT				(0x4)				// 01 = Output
#define GPHCON_1_RTS0				(0x8)				// 10 = nRTS0

#define GPHCON_0					(0x3)				// [1:0]		GPH0
#define GPHCON_0_IN					(0x0)				//*00 = Input
#define GPHCON_0_OUT				(0x1)				// 01 = Output
#define GPHCON_0_CTS0				(0x2)				// 10 = nCTS0

#define GPJCON_RESET				(0x0)				//	Reset Value 0x0


#define LED_NUMBER 					(4)
#define LED_DELAY_JOG				(50)
#define LED_DELAY_MIN				(50)
#define LED_DELAY_MAX				(1000)

#endif /* GPIO_H_ */
