OUTPUT_FORMAT("elf32-littlearm", "elf32-littlearm", "elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(__start)


MEMORY
{
	EXE_BOOT (RX) : ORIGIN = 0x00000000, LENGTH = 0xF00
	MEM_BOOT (R) : ORIGIN = 0x00000F00, LENGTH = 0x100
	EXE (RX) : ORIGIN = 0x00002000, LENGTH = 128K
	RAM (RW) : ORIGIN = 0x00022000, LENGTH = 64K
}
 

SECTIONS
{
	. = 0x00000000;	

	. = ALIGN(4);
	.2440text_init :
	{
	  _stext_init = . ;	
 	  init.o (.text)
	  Nand_Minimal.o (.text)
	  _etext_init = . ;
	} >EXE_BOOT

	. = ALIGN(4); 
   	.2440data_init      :
   	{
	  init.o(.data)
	  Nand_Minimal.o (.data)	  
	}  >MEM_BOOT
	
	. = ALIGN(4); 
   	.2440bss_init      :
   	{
    _sbss_init = .	   	;
	  init.o(.bss)
	  Nand_Minimal.o (.bss)	  	  
	_ebss_init = .		;	  
	}  >MEM_BOOT

	_rom_init_area_size = _ebss_init - _stext_init;
		
	. = ALIGN(4);	
	.text      :
	{
  	  HAL.o (.text)
	  nand.o (.text)  	  
	  _Uart.o (.text)  	  
  	  GPOS.o (.text)	  	
	  _Uart.o (.text)
	  Uart.o (.text)
      libgcc.a(.text)
      libc.a(.text) 	    	  	  
  	  main.o (.text)      
	} >EXE 
	
	. = ALIGN(4);	
   	.bss      :
   	{
   	  _bbss1 = .;
  	  HAL.o (.bss)	  	   	  
	  nand.o (.bss)   	  
  	  GPOS.o (.bss)	  	
	  _Uart.o (.bss)	  
	  Uart.o (.bss)	
	  main.o(.bss)	  
   	  _ebss1 = .;	  
	} >RAM  	  	     	
	
	. = ALIGN(4);	
   	.data      :
   	{
  	  HAL.o (.data)	  	   	
	  nand.o (.data)   	
  	  GPOS.o (.data)	  	
	  _Uart.o (.data)	  
	  Uart.o (.data)	  
	  main.o(.data)	  
	} >RAM 	  	     	

	. = ALIGN(4);
   	.rodata      :
   	{
  	  HAL.o (.rodata)	  	   	
	  nand.o (.rodata)   	
  	  GPOS.o (.rodata)	  	
	  _Uart.o (.rodata)	  
	  Uart.o (.rodata)	  
	  main.o(.rodata)	  
	} >RAM 	  	     	


	. = ALIGN(4);
   	.rodata.str1.4      :
   	{
  	  HAL.o (.rodata.str1.4)	  	   	
	  nand.o (.rodata.str1.4)   	
  	  GPOS.o (.rodata.str1.4)	  	
	  _Uart.o (.rodata.str1.4)	  
	  Uart.o (.rodata.str1.4)	  
	  main.o(.rodata.str1.4)	  
	} >RAM 	  	     	
 
}

 

